=== debian/changelog ===
linphone-desktop (4.3.2-2) unstable; urgency=medium

  * Release to unstable.

 -- Bernhard Schmidt <berni@debian.org>  Mon, 12 Sep 2022 20:41:04 +0200

linphone-desktop (4.3.2-1) experimental; urgency=medium

  [ Dennis Filder ]
  * New upstream version 4.3.2
  * Version numbers are now compiled in correctly everywhere (Closes: #983368).
  * Moved to section "net" from "sound" (Closes: #782357).
  * Many new features due to repackaged dependencies.
    - Text-to-speech support
    - LDAP support
    - Matroska video format (Closes: #979044)
  * Fix date mistruncation issue (Closes: #983369).

 -- Bernhard Schmidt <berni@debian.org>  Sun, 04 Sep 2022 18:31:58 +0000
